<?php
/*

   Copyright 2010 e-WebFace Networks

   Plugin Name: e-WebFace
Plugin URI: http://www.e-webface.com
Version: 1.0
Autor: e-WebFace Networks
Autor URL: http://e-WebFace.com/
Descrição: A e-Webface é um sistema de videoconferência pela web. Este plugin integra a e-Webface com o WordPress permitindo blogueiros criarem e gerenciarem salas de reuniões para interagir com seus leitores para mais informações sobre como configurar o servidor de e-Webface entre em http://www.e-webface.com

Versão 1.0 escrito por Renato Souza Gengo
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
 
jimport('joomla.application.component.controller');
require_once( JPATH_COMPONENT.DS.'includes'.DS.'ewf_api.php');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_ewebfaceconferencing'.DS.'tables');

 
/**
 * ewebface Component Controller
 */
class MeetingsControllerMeeting extends MeetingsController
{
	
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
	 
		// Register Extra tasks
	}

    /**
	 * display the edit form
	 * @return void
	 */
	function add()
	{
		JRequest::setVar( 'view', 'meeting' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);
		
		parent::display();
	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('meeting');
	 
		if ($model->store($post)) {
			$msg = JText::_( 'Meeting Saved!' );
		} else {
			$msg = JText::_( 'Error Saving Meeting - ' );
			$msg .= $model->getError();
		}
	 
		$link = 'index.php?option=com_ewebfaceconferencing';
		$this->setRedirect($link, $msg);
	}
	
	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('meeting');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or More Meetings Could not be Deleted' );
		} else {
			$msg = JText::_( 'Meeting(s) Deleted' );
		}
	 
		$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
	}
	
	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
	} 
	
	/**
	 * Joins a meeting
	 */
	function join()
	{	
		//get the meeting
		$id = JRequest::getVar('id');
		$query = ' SELECT * FROM #__ewf WHERE id ='.$id;
		$db =& JFactory::getDBO();
		$db->setQuery( $query );
		$meeting = $db->loadObject();
			
		if(!$meeting || $meeting == null){
			$msg = "This meeting no longer exists.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
		
		// This is the security salt that must match the value set in the ewebface server
		// This is the URL for the ewebface server
		$row =& JTable::getInstance('settings', 'Table');
		$row->load(1);
		$row->name == 'salt' ? $salt = $row->varValue : $url = $row->varValue;
		$row->load(2);
		$row->name == 'salt' ? $salt = $row->varValue : $url = $row->varValue;

		if(!$salt || $salt == '' || !$url || $url == ''){
			$msg = "You have to fill out the salt and url in the settings menu before you can join a meeting.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
			return;
		}
		
		$user =& JFactory::getUser();
		
		
		
		//Calls create meeting on the ewebface server
		$response = ewebface::createMeetingArray($user->name, $meeting->meetingName."[".$meeting->meetingVersion."]", 'Welcome to '.$meeting->meetingName.'.', $meeting->moderatorPW, $meeting->attendeePW, $salt, $url, JURI::base() );
		$createNew = false;
		//Analyzes the ewebface server's response
		if(!$response){//If the server is unreachable, then prompts the user of the necessary action
			$msg = "Unable to join the meeting. Please check the url of the ewebface server AND check to see if the ewebface server is running.";
		}
		else if( $response['returncode'] == 'FAILED' ) { //The meeting was not created
			if($response['messageKey'] == 'idNotUnique'){
				$createNew = true;
			}
			else if($response['messageKey'] == 'checksumError'){
				$msg = "A checksum error occured. Make sure you entered the correct salt.";
			}
			else{
				$msg = $response['message'];
			}
		}
		else if($response['hasBeenForciblyEnded'] == 'true'){ //The meeting was created, and the user will now be joined
			$createNew = true;
		}
		else{
			$ewf_joinURL = ewebface::joinURL($meeting->meetingName."[".$meeting->meetingVersion."]", $user->username, $meeting->moderatorPW, $salt, $url );
			?><script type="text/javascript"> window.location = "<?php echo $ewf_joinURL ?>";</script><?php
			return;
		}
		
		if($createNew){
		
			$meeting->meetingVersion = time();
			
			$db->updateObject('#__ewf',$meeting,'id',false);
			if ($db->getErrorNum()) {  
				$msg = $db->getErrorMsg();  
				$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
			}			
			
			//Calls create meeting on the ewebface server
			$response = ewebface::createMeetingArray($user->name, $meeting->meetingName."[".$meeting->meetingVersion."]", 'Welcome to '.$meeting->meetingName.'.', $meeting->moderatorPW, $meeting->attendeePW, $salt, $url, JURI::base() );
			
			if(!$response){//If the server is unreachable, then prompts the user of the necessary action
				$msg = "Unable to join the meeting. Please check the url of the ewebface server AND check to see if the ewebface server is running.";
			}
			else if( $response['returncode'] == 'FAILED' ) { //The meeting was not created
				if($response['messageKey'] == 'checksumError'){
					$msg = "A checksum error occured. Make sure you entered the correct salt.";
				}
				else{
					$msg = $response['message'];
				}
			}
			else{
				$ewf_joinURL = ewebface::joinURL($meeting->meetingName."[".$meeting->meetingVersion."]", $user->username, $meeting->moderatorPW, $salt, $url );
				?><script type="text/javascript"> window.location = "<?php echo $ewf_joinURL ?>";</script><?php
				return;
			}
		}

		$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		return;			
	} 
	
	/**
	 * Deletes a meeting
	 */
	function delete()
	{	
		//get the meeting
		$id = JRequest::getVar('id');
		$query = ' SELECT * FROM #__ewf WHERE id ='.$id;
		$db =& JFactory::getDBO();
		$db->setQuery( $query );
		$meeting = $db->loadObject();
			
		if(!$meeting || $meeting == null){
			$msg = "This meeting no longer exists.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
		
		// This is the security salt that must match the value set in the ewebface server
		// This is the URL for the ewebface server
		$row =& JTable::getInstance('settings', 'Table');
		$row->load(1);
		$row->name == 'salt' ? $salt = $row->varValue : $url = $row->varValue;
		$row->load(2);
		$row->name == 'salt' ? $salt = $row->varValue : $url = $row->varValue;

		if(!$salt || $salt == '' || !$url || $url == ''){
			$msg = "You have to fill out the salt and url in the settings menu before you can delete a meeting.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
			return;
		}

		$response = ewebface::endMeeting( $meeting->meetingName."[".$meeting->meetingVersion."]", $meeting->moderatorPW, $url, $salt);
		
		//Analyzes the ewebface server's response
		if(!$response){//If the server is unreachable, then prompts the user of the necessary action
			$msg = "Unable to join the meeting. Please check the url of the ewebface server AND check to see if the ewebface server is running.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
		else if( $response['returncode'] == 'FAILED' && $response['messageKey'] != 'notFound'  ) { //The meeting was not created
			if($response['messageKey'] == 'checksumError'){
				$msg = "A checksum error occured. Make sure you entered the correct salt.";
			}
			else{
				$msg = $response['message'];
			}
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
		else{ //The meeting was created, and the user will now be joined
			$query = "DELETE FROM #__ewf WHERE id=".$id;
			$db->setQuery( $query );
			$db->query();
			
			$msg = $meeting->meetingName." has been deleted.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
	}
	
	
	/**
	 * Ends a meeting
	 */
	function end()
	{	
		//get the meeting
		$id = JRequest::getVar('id');
		$query = ' SELECT * FROM #__ewf WHERE id ='.$id;
		$db =& JFactory::getDBO();
		$db->setQuery( $query );
		$meeting = $db->loadObject();
			
		if(!$meeting || $meeting == null){
			$msg = "This meeting no longer exists.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
		
		// This is the security salt that must match the value set in the ewebface server
		// This is the URL for the ewebface server
		$row =& JTable::getInstance('settings', 'Table');
		$row->load(1);
		$row->name == 'salt' ? $salt = $row->varValue : $url = $row->varValue;
		$row->load(2);
		$row->name == 'salt' ? $salt = $row->varValue : $url = $row->varValue;

		if(!$salt || $salt == '' || !$url || $url == ''){
			$msg = "You have to fill out the salt and url in the settings menu before you can delete a meeting.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
			return;
		}

		$response = ewebface::endMeeting( $meeting->meetingName."[".$meeting->meetingVersion."]", $meeting->moderatorPW, $url, $salt);
		
		//Analyzes the ewebface server's response
		if(!$response){//If the server is unreachable, then prompts the user of the necessary action
			$msg = "Unable to join the meeting. Please check the url of the ewebface server AND check to see if the ewebface server is running.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
		else if( $response['returncode'] == 'FAILED' ) { //The meeting was not created
			if($response['messageKey'] == 'checksumError'){
				$msg = "A checksum error occured. Make sure you entered the correct salt.";
			}
			else{
				$msg = $response['message'];
			}
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
		else{ //The meeting was created, and the user will now be joined
			$msg = $meeting->meetingName." has been terminated.";
			$this->setRedirect( 'index.php?option=com_ewebfaceconferencing', $msg );
		}
	}
}